import {
  TwindContext
} from "../chunk.Y66U25MY.js";
import {
  W,
  Ye,
  de
} from "../chunk.DIBIIWL5.js";

// src/runtime/styling/index.ts
import {
  createElement,
  useContext
} from "react";

// node_modules/twind/twind.js
var Te;
var Tt = (e, t) => (typeof t == "function" && (Te = false), t);
var vt = (e) => {
  Te = true;
  let t = JSON.stringify(e, Tt);
  return Te && t;
};
var te = (e, t) => {
  let n = vt(t), r;
  if (n) {
    var i = Ye.get(e);
    i || Ye.set(e, i = new Map()), r = i.get(n);
  }
  return r || (r = Object.defineProperty((o, a2) => (a2 = Array.isArray(o) ? a2 : o, W(e(t, a2), a2)), "toJSON", {value: () => n || t}), i && (i.set(n, r), de(i, 1e4))), r;
};

// node_modules/twind/css/css.js
var g = (e, t = 1) => e.slice(t);
var d = (e) => e.replace(/[A-Z]/g, "-$&").toLowerCase();
var S = (e, t) => {
  for (; typeof e == "function"; )
    e = e(t);
  return e;
};
var l = (e, t, n) => t ? Object.keys(t).reduce((r, s) => {
  let i = S(t[s], n);
  return i && typeof i == "object" && !Array.isArray(i) ? r[s] = l(r[s] || {}, i, n) : r[d(s)] = i, r;
}, e) : e;
var j = typeof CSS != "undefined" && CSS.escape || ((e) => {
  let t = e.charCodeAt(0), n = "";
  return t >= 48 && t <= 57 && (n = "\\" + t.toString(16) + " ", e = g(e)), n + e.replace(/[!./:#]/g, "\\$&");
});
var T = (e, t) => {
  let n = (r, s) => Array.isArray(s) ? s.reduce(n, r) : l(r, S(s, t), t);
  return e.reduce(n, {});
};
var b = /\s*(?:([\w-%@]+)\s*:?\s*([^{;]+?)\s*(?:;|$|})|([^;}{]*?)\s*{)|(})/gi;
var w = /\/\*[\s\S]*?\*\/|\s+|\n/gm;
var C = (e, t) => e.reduceRight((n, r) => ({[r]: n}), t);
var a = (e, t, n) => {
  n && e.push(C(t, n));
};
var k = (e, t, n) => {
  let r = e[0], s = [];
  for (let i = 0; i < t.length; ) {
    let o = S(t[i], n);
    o && typeof o == "object" ? (s.push(r, o), r = e[++i]) : r += (o || "") + e[++i];
  }
  return s.push(r), s;
};
var v = (e) => {
  let t = [], n = [], r, s;
  for (let i = 0; i < e.length; i++) {
    let o = e[i];
    if (typeof o == "string")
      for (; s = b.exec(o.replace(w, " ")); ) {
        if (!s[0])
          continue;
        s[4] && (r = a(n, t, r), t.pop()), s[3] ? (r = a(n, t, r), t.push(s[3])) : s[4] || (r || (r = {}), s[2] && /\S/.test(s[2]) ? r[s[1]] = s[2] : e[++i] && (r[s[1]] = e[i]));
      }
    else
      r = a(n, t, r), n.push(C(t, o));
  }
  return a(n, t, r), n;
};
var c = (e, t) => T(Array.isArray(e[0]) && Array.isArray(e[0].raw) ? v(k(e[0], e.slice(1), t)) : e, t);
var p = (...e) => te(c, e);

// src/runtime/styling/index.ts
import {MDXProvider, useMDXComponents} from "@mdx-js/react";
function styledHtml(elementType) {
  return function boundStyled(...args) {
    const directive = p(...args);
    return function boundStyledElement(props) {
      return renderStyled(elementType, props, directive);
    };
  };
}
function renderStyled(elementType, {className, ...props} = {}, directive) {
  const tw = useContext(TwindContext);
  const styledClassName = tw(directive);
  return createElement(elementType, {
    ...props,
    className: `${className}${className ? " " : ""}${styledClassName}`
  });
}
var styled = new Proxy(Object.create(null), {
  apply(_target, _this, elementType, ...args) {
    const directive = p(...args);
    return function boundStyledElement({className, ...props} = {}) {
      return renderStyled(elementType, props, directive);
    };
  },
  get(_t, elementType) {
    return styledHtml(elementType);
  }
});
export {
  MDXProvider,
  styled,
  useMDXComponents
};
